using System;
using System.Collections;
using System.ComponentModel;
using System.Web;
using System.Web.SessionState;
using System.Data.SqlClient;
using Microsoft.Web.UI.WebControls;

namespace UserSites 
{
	/// <summary>
	/// Summary description for Global.
	/// </summary>
	public class Global : System.Web.HttpApplication
	{
		public Global()
		{
			InitializeComponent();
		}	
		
		protected void Application_Start(Object sender, EventArgs e)
		{

		}
 
		protected void Session_Start(Object sender, EventArgs e)
		{
			MDO.SiteTable siteTable = buildSiteTable();
			Session["VhaSiteTable"] = siteTable;

			setDbConnection();
		}

		private void setDbConnection() 
		{
			String sConnCard = "";
			String sConn = "";
			SqlConnection connection = new SqlConnection(sConn);
			SqlConnection connCard = new SqlConnection(sConnCard);
			Session["Connection"] = connection;
			Session["ConnCard"] = connCard;
		}

		private MDO.SiteTable buildSiteTable() 
		{
			MDO.DAOFactory daoFactory = MDO.DAOFactory.getDAOFactory(MDO.DAOFactory.getConstant("XML"));
			MDO.DataSourceDAO dao = daoFactory.getDataSourceDAO();
			string currentPath = Request.PhysicalPath;
			int p = currentPath.LastIndexOf("\\");
			string xmlPath = currentPath.Substring(0,p) + "\\..\\resources\\xml\\vhaSites.xml";
			dao.setSource(xmlPath);
			return dao.buildSiteTable();
		}

		public static void populateTree(TreeView SiteTree, MDO.SiteTable siteTable, String URL) 
		{
			TreeNode root = new TreeNode();
			root.Text = "VHA";
			root.NavigateUrl = "";
			root.Expanded = true;
			SiteTree.Nodes.Add(root);

			MDO.Region[] regions = siteTable.getRegions();
			String defaultCss = "color:white;font-weight:bold;font-family:georgia;font-size:8pt";
			String selectedCss = "color:red;font-weight:bold;font-family:georgia;font-size:8pt";
			String hoverCss = "color:gold;font-weight:bold;font-family:georgia;font-size:10pt;text-decoration:none";
			for (int r=0; r<regions.Length; r++) 
			{
				TreeNode regionNode = new TreeNode();
				regionNode.Text = regions[r].getID() + ": " + regions[r].getName();
				regionNode.DefaultStyle.CssText = defaultCss;
				regionNode.SelectedStyle.CssText = selectedCss;
				regionNode.HoverStyle.CssText = hoverCss;
				regionNode.NavigateUrl = "";
				MDO.Site[] sites = regions[r].getSites();
				for (int s=0; s<sites.Length; s++) 
				{
					TreeNode siteNode = new TreeNode();
					siteNode.Text = sites[s].getDisplayName();
					siteNode.DefaultStyle.CssText = defaultCss;
					siteNode.SelectedStyle.CssText = selectedCss;
					siteNode.HoverStyle.CssText = hoverCss;
					siteNode.ID = sites[s].getID();
					siteNode.NavigateUrl = URL + "?ID=" + sites[s].getID();
					siteNode.Target = "WorkPanel";
					regionNode.Nodes.Add(siteNode);
				}
				root.Nodes.Add(regionNode);
			}
		}

		protected void Application_BeginRequest(Object sender, EventArgs e)
		{

		}

		protected void Application_EndRequest(Object sender, EventArgs e)
		{

		}

		protected void Application_AuthenticateRequest(Object sender, EventArgs e)
		{

		}

		protected void Application_Error(Object sender, EventArgs e)
		{

		}

		protected void Session_End(Object sender, EventArgs e)
		{

		}

		protected void Application_End(Object sender, EventArgs e)
		{

		}
			
		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
		}
		#endregion
	}
}

