using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Microsoft.Web.UI.WebControls;
using gov.va.med.vistaweb.util;

namespace UserSites
{
	/// <summary>
	/// Summary description for Login.
	/// </summary>
	public class Login : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox welcomeBox;
		protected System.Web.UI.WebControls.TextBox accessCodeBox;
		protected System.Web.UI.WebControls.TextBox verifyCodeBox;
		protected System.Web.UI.WebControls.Button submitButton;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			String urlArgs = Request.QueryString.ToString();
			String[] flds = StringUtils.Split(urlArgs,StringUtils.EQUALS);
			String siteID = flds[1];

			if (!Page.IsPostBack) 
			{
				MDO.SiteTable siteTable = (MDO.SiteTable)Session["VhaSiteTable"];
				MDO.Site loginSite = siteTable.getSite(siteID);
				MDO.DataSource his = loginSite.getHIS();
				if (his.getStatus() != MDO.DataSource.ACTIVE) 
				{
					Response.Write(loginSite.getName() + " is not active: " + his.getStatus());
					Response.End();
				}
				MDO.DAOFactory daoFactory = MDO.DAOFactory.getDAOFactory(MDO.DAOFactory.getConstant(his.getProtocol()));
				MDO.DataSourceDAO loginDao = daoFactory.getDataSourceDAO();
				loginDao.setSite(loginSite);
				loginDao.setProps(his);
				try 
				{
					loginDao.connect();
					welcomeBox.Text = loginDao.getWelcome();
					Session["LoginDao"] = loginDao;
				} 
				catch (MDO.MDOException me) 
				{
					Response.Write(me.getMessage());
					Response.End();
				}
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.submitButton.Click += new System.EventHandler(this.submitButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void submitButton_Click(object sender, System.EventArgs e)
		{
			if (accessCodeBox.Text == "") return;
			String accessCode = accessCodeBox.Text;
			String verifyCode = verifyCodeBox.Text;
			if (accessCode.IndexOf(";") != -1) 
			{
				String[] parts = accessCode.Split(';');
				accessCode = parts[0];
				verifyCode = parts[1];
			}
			if (verifyCode == "") return;
			MDO.DataSourceDAO loginDao = (MDO.DataSourceDAO)Session["LoginDao"];
			MDO.User user = new MDO.User();
			user.setUsername(accessCode);
			user.setPassword(verifyCode);
			user.setPermissions("OR CPRS GUI CHART");
			try 
			{
				loginDao.login(user);
				loginDao.setProperties(user);
				user.setSite(loginDao.getSite());
				Session["User"] = user;
				Response.Redirect("ChangeFrameset.htm?Set=UserSelectFrameset.htm",true);
			} 
			catch (MDO.MDOException me) 
			{
				Response.Write("Unable to log onto " + loginDao.getSite().getName() + "<p>" + me.getMessage());
				Response.End();
			}
		}
	}
}
