using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Microsoft.Web.UI.WebControls;
using gov.va.med.vistaweb.util;

namespace UserSites
{
	/// <summary>
	/// Summary description for LoginSiteSelection.
	/// </summary>
	public class SiteSelection : System.Web.UI.Page
	{
		protected Microsoft.Web.UI.WebControls.TreeView SiteTree;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			MDO.SiteTable siteTable = (MDO.SiteTable)Session["VhaSiteTable"];
			populateTree(SiteTree,siteTable,"Sites.aspx");
		}

		public static void populateTree(TreeView SiteTree, MDO.SiteTable siteTable, String URL) 
		{
			TreeNode root = new TreeNode();
			root.Text = "VHA";
			root.NavigateUrl = "";
			root.Expanded = true;
			SiteTree.Nodes.Add(root);

			MDO.Region[] regions = siteTable.getRegions();
			String defaultCss = "color:white;font-weight:bold;font-family:georgia;font-size:8pt";
			String selectedCss = "color:red;font-weight:bold;font-family:georgia;font-size:8pt";
			String hoverCss = "color:gold;font-weight:bold;font-family:georgia;font-size:10pt;text-decoration:none";
			for (int r=0; r<regions.Length; r++) 
			{
				TreeNode regionNode = new TreeNode();
				regionNode.Text = regions[r].getID() + ": " + regions[r].getName();
				regionNode.DefaultStyle.CssText = defaultCss;
				regionNode.SelectedStyle.CssText = selectedCss;
				regionNode.HoverStyle.CssText = hoverCss;
				regionNode.NavigateUrl = URL + "?VisnID=" + regions[r].getID();
				MDO.Site[] sites = regions[r].getSites();
				for (int s=0; s<sites.Length; s++) 
				{
					TreeNode siteNode = new TreeNode();
					siteNode.Text = sites[s].getDisplayName();
					siteNode.DefaultStyle.CssText = defaultCss;
					siteNode.SelectedStyle.CssText = selectedCss;
					siteNode.HoverStyle.CssText = hoverCss;
					siteNode.ID = sites[s].getID();
					siteNode.NavigateUrl = URL + "?SiteID=" + sites[s].getID();
					siteNode.Target = "WorkPanel";
					regionNode.Nodes.Add(siteNode);
				}
				root.Nodes.Add(regionNode);
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.SiteTree.SelectedIndexChange += new Microsoft.Web.UI.WebControls.SelectEventHandler(this.SiteTree_SelectedIndexChange);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void SiteTree_SelectedIndexChange(object sender, Microsoft.Web.UI.WebControls.TreeViewSelectEventArgs e)
		{
			TreeView tv = (TreeView)sender;
			String selectedNode = tv.SelectedNodeIndex;
			String[] flds = StringUtils.Split(selectedNode,StringUtils.PERIOD);
			MDO.SiteTable siteTable = (MDO.SiteTable)Session["VhaSiteTable"];
			MDO.Region[] regions = siteTable.getRegions();
			int r = Convert.ToInt16(flds[1]);
			MDO.Site[] sites = regions[r].getSites();
			int s = Convert.ToInt16(flds[2]);
			Session["SelectedSite"] = sites[s];
		}

	}
}
