using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using gov.va.med.vistaweb.util;

namespace UserSites
{
	/// <summary>
	/// Summary description for UserSelection.
	/// </summary>
	public class UserSelection : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox findBox;
		protected System.Web.UI.WebControls.Button findButton;
		protected System.Web.UI.WebControls.ListBox matchesList;
		protected System.Web.UI.WebControls.Button okButton;
		protected System.Web.UI.WebControls.TextBox statusBox;
		protected System.Web.UI.WebControls.Label lookupSiteLabel;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			Response.CacheControl = "no-cache";
			Response.AddHeader("Pragma", "no-cache");
			Response.Expires = -1;

			if (!Page.IsPostBack) 
			{
				String urlArgs = Request.QueryString.ToString();
				if (urlArgs != "") 
				{
					String[] flds = StringUtils.Split(urlArgs,StringUtils.EQUALS);
					String lookupSiteID = "";
					if (flds.Length == 2) lookupSiteID = flds[1];
					MDO.SiteTable siteTable = (MDO.SiteTable)Session["VhaSiteTable"];
					MDO.Site site = siteTable.getSite(lookupSiteID);
					Session["LookupSite"] = site;
				}

				MDO.DataSourceDAO lookupDao = null;

				MDO.DataSourceDAO loginDao = (MDO.DataSourceDAO)Session["LoginDao"];
				MDO.Site loginSite = loginDao.getSite();

				if (Session["LookupSite"] == null) 
				{
					Session["LookupSite"] = loginSite;
				}
				MDO.Site lookupSite = (MDO.Site)Session["LookupSite"];
				if (lookupSite == loginSite) 
				{
					lookupDao = (MDO.DataSourceDAO)Session["LoginDao"];
				} 
				else 
				{
					MDO.DataSource his = lookupSite.getHIS();
					MDO.DAOFactory daoFactory = MDO.DAOFactory.getDAOFactory(MDO.DAOFactory.getConstant(his.getProtocol()));
					lookupDao = daoFactory.getDataSourceDAO();
					lookupDao.setProps(his);
					lookupDao.setSite(lookupSite);
					MDO.Patient patient = (MDO.Patient)Session["Patient"];
					MDO.User user = (MDO.User)Session["User"];
					try 
					{
						lookupDao.setupVisitor(user,loginSite);
					} 
					catch (MDO.MDOException me) 
					{
						Response.Write("Lookup cannot be performed at " + lookupSite.getName() + ": " + me.getMessage());
						Response.End();
					}
				} 
				lookupSiteLabel.Text = lookupDao.getSite().getName();
				Session["RequestSite"] = lookupDao.getSite();	// For logging...
				Session["LookupDao"] = lookupDao;
			}
		}

		private void findButton_Click(object sender, System.EventArgs e)
		{
			if (findBox.Text == "") 
			{
				statusBox.Text = "No lookup criterion!";
				return;
			}
			MDO.DataSourceDAO lookupDao = (MDO.DataSourceDAO)Session["LookupDao"];
			string sFind = findBox.Text;
			sFind = sFind.Replace(", ",",");
			MDO.User[] matches = null;
			try 
			{
				matches = lookupDao.userLookup(sFind);
			} 
			catch (MDO.MDOException me) 
			{
				statusBox.Text = "Error doing lookup: " + me.getMessage();
				return;
			}
			if (matches == null || matches.Length == 0) 
			{
				statusBox.Text = "No matches";
				return;
			}
			Session["Matches"] = matches;
			matchesList.Items.Clear();
			for (int i=0; i<matches.Length; i++) 
			{
				if(!matches[i].getLastName().Equals(""))
				{
					ListItem item = new ListItem(matches[i].getLastNameFirst(),matches[i].getID());
					matchesList.Items.Add(item);
				}
				else
				{
					ListItem item = new ListItem(matches[i].getVistaFullName(),matches[i].getID());
					matchesList.Items.Add(item);
				}
			}
			matchesList.Items[0].Selected = true;
			statusBox.Text = "Select user from Match list and click OK.";
			okButton.Enabled = true;
		}

		private void okButton_Click(object sender, System.EventArgs e)
		{
			MDO.User[] matches = (MDO.User[])Session["Matches"];
			MDO.User provider = matches[matchesList.SelectedIndex];
			provider.setSite((MDO.Site)Session["LookupSite"]);
			Session["Provider"] = provider;

			//MDO.DataSourceDAO lookupDao = (MDO.DataSourceDAO)Session["LookupDao"];


			/*
			MDO.DAOFactory daoFactory = MDO.DAOFactory.getDAOFactory(MDO.DAOFactory.getConstant("VISTA"));
			MDO.MultiSiteDAO multiSiteDAO = daoFactory.getMultiSiteDAO();
			MDO.MultiSiteData data = new MDO.MultiSiteData();
			data.user = (MDO.User)Session["User"];
			MDO.DataSourceDAO loginDao = (MDO.DataSourceDAO)Session["LoginDao"];
			data.userSite = loginDao.getSite();
			data.patient = patient;
			data.lookupDao = lookupDao;
			data.remoteSites = remoteSites;
			data.siteTable = (MDO.SiteTable)Session["VhaSiteTable"];
			multiSiteDAO.setDAOs(data);
			try 
			{
				multiSiteDAO.setDeceasedDates(patient);
				multiSiteDAO.setSensitivityRecords(patient);
			} 
			catch (MDO.MDOException me) 
			{
				Response.Write("Unexpected error: " + me.getMessage());
				Response.End();
			}
			Session["MultiSiteDAO"] = multiSiteDAO;
      */ 
			Session["Provider"] = provider;
			Response.Redirect("ChangeFrameset.htm?Set=AppFrameset.htm",true);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.findButton.Click += new System.EventHandler(this.findButton_Click);
			this.okButton.Click += new System.EventHandler(this.okButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
